#ifndef SCHEMEEDITOR_SINGLE_AUTOMATIC_DIALOG_H
#define SCHEMEEDITOR_SINGLE_AUTOMATIC_DIALOG_H

#include <vector>
#include <QDialog>
#include <QVBoxLayout>
#include "comdel/domain/value.h"
#include "comdel/domain/instance_attribute.h"
#include "generic_dialog.h"

namespace display {

    class SingleAutomaticDialog: public GenericDialog {
        domain::Value firstValue;
        domain::Value secondValue;
        std::vector<domain::InstanceAttribute> &attributes;

    public:
        explicit SingleAutomaticDialog(
                std::string title,
                std::string action,
                std::vector<domain::InstanceAttribute>& values);

    protected:
        bool onUpdate() override;
        void setupValues(QVBoxLayout *layout, domain::InstanceAttribute &attribute, void (display::SingleAutomaticDialog::* handler)(int));

    public slots:

        void onFirstEnumerationChanged(int index);
        void onSecondEnumerationChanged(int index);
    };

} // display

#endif //SCHEMEEDITOR_SINGLE_AUTOMATIC_DIALOG_H
