#include "pin.h"

namespace domain {

    Pin::Pin(std::string name, PinType type, std::string tooltip, std::optional<std::string> connection, domain::ui::Pin pin,
             std::optional<std::vector<Value>> wires)
            : name(name), type(type), tooltip(tooltip), connection(connection), displayPin(pin), wires(wires) {}

    std::string &Pin::getName() {
        return name;
    }

    Pin::PinType Pin::getType() {
        return type;
    }

    std::string Pin::getTooltip() {
        return tooltip;
    }

    ui::Pin &Pin::getDisplayPin() {
        return displayPin;
    }

    std::optional<std::string> Pin::getConnection() {
        return connection;
    }

    std::optional<std::vector<Value>> &Pin::getWires() {
        return wires;
    }


} // namespace domain
